﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="RadDatePickerImprovedKeyboardNavigation.aspx.cs" Inherits="RadDatePickerImprovedKeyboardNavigation" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
</head>
<body>
    <form id="form1" runat="server">
        <telerik:RadScriptManager ID="RadScriptManager1" runat="server">
            <Scripts>
                <asp:ScriptReference Assembly="Telerik.Web.UI" Name="Telerik.Web.UI.Common.Core.js" />
                <asp:ScriptReference Assembly="Telerik.Web.UI" Name="Telerik.Web.UI.Common.jQuery.js" />
                <asp:ScriptReference Assembly="Telerik.Web.UI" Name="Telerik.Web.UI.Common.jQueryInclude.js" />
            </Scripts>
        </telerik:RadScriptManager>
        <telerik:RadScriptBlock ID="RadScriptBlock1" runat="server">
            <script type="text/javascript">
                //Put your JavaScript code here.
                var carPos = -1;
                function keyDown(inputEl, event) {

                    var code = event.keyCode;
                    if (code == 37 || code == 39) { return; }

                    var dateInput = $find(inputEl.id);
                    carPos = dateInput.get_caretPosition();
                    var picker = dateInput.get_owner();
                    var value = inputEl.value;

                    var date = picker.get_selectedDate();
                    var month = date.getMonth();
                    var newMonth = -1;

                    if (carPos > 3 && carPos < 10) {
                        switch (code) {
                            case 65:                       // April, August
                                newMonth = month == 3 ? 7 : 3;
                                break;
                            case 68: newMonth = 11; break; // December
                            case 70: newMonth = 1; break;  // February
                            case 74:                       // January, June, July
                                newMonth = month == 5 ? 6 : month == 0 ? 5 : 0;
                                break;
                            case 77:                       // March, May
                                newMonth = month == 2 ? 4 : 2;
                                break;
                            case 78: newMonth = 10; break; // November
                            case 79: newMonth = 9; break;  // October
                            case 83: newMonth = 8; break;  // September
                            default: break;
                        }
                        $get('<%= HiddenField1.ClientID %>').value = carPos;
                    }
                    if (code > 47 && code < 58) {
                        if (carPos < 4) {
                            carPos = carPos == 0 ? 0 : 1;
                            if (carPos == 0) {
                                $get('<%= HiddenField1.ClientID %>').value = 1;
                            }
                            if (carPos == 1) {
                                $get('<%= HiddenField1.ClientID %>').value = 5;
                            }

                            value = value.substr(0, carPos) + event.key + value.substr(carPos + 1);
                            inputEl.value = value;
                            $find(inputEl.id).set_caretPosition(1 + 4 * carPos);

                            var maxDays = (new Date(date.getFullYear(), month + 1, 0)).getDate();
                            if (parseInt(value.substring(0, 2)) > maxDays) {
                                value = maxDays.toString() + value.substr(2);
                                inputEl.value = value;
                                $find(inputEl.id).set_caretPosition(5);
                            }

                            var newDays = parseInt(value.substring(0, 2));
                            picker.set_selectedDate(new Date(picker.get_selectedDate().setDate(newDays)));
                        }
                        else if (carPos > 9) {
                            if (carPos == 10) {
                                carPos = 11;
                            }

                            value = value.substr(0, carPos) + event.key + value.substr(carPos + 1);
                            inputEl.value = value;

                            var year = parseInt(value.substr(11, 4));
                            if (year < 1900 || year > 3000) {
                                year = year < 1900 ? 1900 : 2999;
                                value = value.substr(0, 11) + year.toString();
                                inputEl.value = value;
                            }
                            var newYears = parseInt(value.substr(11, 4));
                            $get('<%= HiddenField1.ClientID %>').value = carPos + 1;
                            $find(inputEl.id).set_caretPosition(carPos + 1);

                            picker.set_selectedDate(new Date(picker.get_selectedDate().setYear(newYears)));
                        }
                }
                if (newMonth >= 0) {
                    picker.set_selectedDate(new Date(date.setMonth(newMonth)));
                }

                if (code == 9) {
                    var newCarPos = -1;
                    if (carPos < 4) {
                        newCarPos = 5;
                    }
                    else if (carPos < 10) {
                        if (event.shiftKey) {
                            newCarPos = 0;
                        }
                        else {
                            newCarPos = 11;
                        }
                    }
                    else {
                        if (event.shiftKey) {
                            newCarPos = 5;
                        }
                        else {
                            return;
                        }
                    }
                    if (newCarPos >= 0) {
                        $find(inputEl.id).set_caretPosition(newCarPos);
                    }
                }
                $telerik.cancelRawEvent(event);

            }
            function dateInputFocus(sender, args) {
                if (!sender.get_selectedDate()) {
                    sender.set_selectedDate(new Date());
                }
            }
            function dateSelected(sender, args) {
                var savedPos = parseInt($get('<%= HiddenField1.ClientID %>').value);

                if (savedPos >= 0) {
                    sender.get_dateInput().set_caretPosition(savedPos);
                }
            }
        </script>
        </telerik:RadScriptBlock>
        <telerik:RadAjaxPanel ID="RadAjaxPanel1" runat="server">
            <telerik:RadDatePicker ID="RadDatePicker1" runat="server" Skin="Bootstrap"
                MinDate="1/1/1900" MaxDate="1/1/3000">
                <DateInput runat="server" DateFormat="dd / MMM / yyyy" onkeydown="keyDown(this,event);" SelectionOnFocus="None"
                    EmptyMessage="-- / -- / --">
                    <ClientEvents OnFocus="dateInputFocus" />
                </DateInput>
                <ClientEvents OnDateSelected="dateSelected" />
            </telerik:RadDatePicker>
            <asp:RequiredFieldValidator ID="RequiredFieldValidator1" runat="server" ErrorMessage="*Select a Valid Date"
                ForeColor="Red" ControlToValidate="RadDatePicker1" Font-Names='"Helvetica Neue",Helvetica,Arial,sans-serif'>
            </asp:RequiredFieldValidator>
            <br />
            <br />
            <telerik:RadPushButton ID="RadPushButton1" runat="server" Text="Submit"
                Skin="Bootstrap" OnClick="RadPushButton1_Click">
            </telerik:RadPushButton>
            <br />
            <br />
            <telerik:RadLabel ID="RadLabel2" runat="server" Skin="Bootstrap"
                Text="Output">
            </telerik:RadLabel>
            <asp:HiddenField ID="HiddenField1" runat="server" Value="-1" />
        </telerik:RadAjaxPanel>
    </form>
</body>
</html>
